/*-----------------------------------------------------------------------

File  : code_generator.h

Author: Stephan Schulz

Contents
 
  Code generator for the PL->C Compiler

  Copyright 1998-2002 by the author.
  This code is released under the GNU General Public Licence.
  See the file COPYING in the main CLIB directory for details.
  Run "eprover -h" for contact information.

Changes

<1> Wed Oct 30 18:18:24 EST 2002
    New

-----------------------------------------------------------------------*/

#ifndef CODE_GENERATOR

#define CODE_GENERATOR


#include "parser.h"
#include "bintree.h"


/*---------------------------------------------------------------------*/
/*                    Data type declarations                           */
/*---------------------------------------------------------------------*/




/*---------------------------------------------------------------------*/
/*                Exported Functions and Variables                     */
/*---------------------------------------------------------------------*/

extern char* static_preamble;
extern char* static_postamble;

void PrintStatementC(Statement_p statement, int indent);
void PrintProgramC(Prog_p prog, int indent);

void CollectProgVars(Prog_p prog, BinTree_p *X, BinTree_p *Y, 
                     BinTree_p *Z);
void CollectStatementVars(Statement_p statement, BinTree_p *X,
			  BinTree_p *Y, BinTree_p *Z);
void PrintVarDefs(BinTree_p tree, char* basename);
void PrintVarInits(BinTree_p tree, char* basename, bool input);
void PrintVarValues(BinTree_p tree, char* basename);


#endif

/*---------------------------------------------------------------------*/
/*                        End of File                                  */
/*---------------------------------------------------------------------*/





