#include <ctype.h>
#include "code_generator.h"


int main(int argc, char* argv[])
{
   Prog_p prog;
   BinTree_p X=NULL,Y=NULL,Z=NULL;

   assert(argc==2);

   ProgName = "sh_test";
   InitSourceHandler(argv[1]);
   current = NextToken();
   prog = ParseProg();
   CollectProgVars(prog, &X,&Y,&Z);
   printf("%s",static_preamble);
   PrintVarDefs(X,"X");
   PrintVarDefs(Y,"Y");
   PrintVarDefs(Z,"Z");
   printf("\n"); 
   PrintVarInits(X,"X", 1);
   PrintVarInits(Y,"Y", 0);
   PrintVarInits(Z,"Z", 0);
   printf("\n");
   printf("   printf(\"Input Configuration\\n\");\n");
   PrintVarValues(X,"X");
   printf("\n   /* Preamble ends! */ \n\n");
   PrintProgramC(prog, 0);
   printf("\n   /* Translated program ends! */ \n\n");
   printf("   printf(\"Output Configuration\\n\");\n");
   PrintVarValues(Z,"Z");
   printf("%s",static_postamble);
   ExitSourceHandler();
   return EXIT_SUCCESS;
}
