/*-----------------------------------------------------------------------

File  : utilities.h

Author: Stephan Schulz

Contents
 
  Declarations for basic services for instructive example programs. 

  Copyright 1998-2002 by the author.
  This code is released under the GNU General Public Licence.
  See the file COPYING.

Changes

<1> Wed Sep 11 01:10:05 CEST 2002
    New

-----------------------------------------------------------------------*/

#ifndef UTILITIES

#define UTILITIES

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

/*---------------------------------------------------------------------*/
/*                    Data type declarations                           */
/*---------------------------------------------------------------------*/


typedef enum
{
   false = 0,
   true = 1
}bool;

#ifdef NULL
#undef NULL
#endif

#define NULL ((void*)0)

typedef struct
{
   char* str;
   int   len;
   int   mem;
}dynastring;

typedef dynastring *dynastring_p;

#define DYNASTR_GROW 64

/*---------------------------------------------------------------------*/
/*                Exported Functions and Variables                     */
/*---------------------------------------------------------------------*/

extern char* ProgName;

void  Error(char* message);
void* SecureMalloc(int size);
void* SecureRealloc(void *ptr, int size);
char* SecureStrdup(char* source);
void  DynastringInit(dynastring_p string);
void  DynastringReset(dynastring_p string);
void  DynastringFreemem(dynastring_p string);
char* DynastringAppendChar(dynastring_p string, char c);

#endif

/*---------------------------------------------------------------------*/
/*                        End of File                                  */
/*---------------------------------------------------------------------*/








